import { Form, Row } from "react-bootstrap";
import { Controller, useForm } from "react-hook-form";
import { useTranslation } from "react-i18next";
// import validator from "validator";

type FormData = {
  sport: string;
  boatName: string;
  startTime: string;
  estimatedEndTime: string;
  destination: string;
  name: string;
  email: string;
  annotations: string;
};

function BoatInfo(props: any) {

  const {
    control,
    handleSubmit,
    formState: { errors },
  } = useForm<FormData>({
    mode: "onBlur"
  });
  const { t } = useTranslation();

  const onSubmit = (data: FormData) => {
    try {
      /**
       * Logic to handle authentication. Should be separated into a service in another file.
       * await login(data);
       *
       *
       * navigate("/boatManager");
       */
    } catch (e) {
      alert("error");
    }
  };

  return (
    <Form onSubmit={handleSubmit(onSubmit)}>
      <Row>
        <Controller
          name="boatName"
          control={control}
          defaultValue={props.boatName}
          render={({ field }) => (
            <div className="mb-2 col">
              <Form.Label>{t("bookingForm.labelBoatName")}</Form.Label>
              <Form.Control disabled type="text" {...field} />
            </div>
          )}
        />
        <Controller
          name="sport"
          control={control}
          defaultValue={props.sport}
          render={({ field }) => (
            <div className="mb-2 col">
              <Form.Label >{t("bookingForm.labelSport")}</Form.Label>
              <Form.Control disabled type="text" {...field} />
            </div>
          )}
        />
      </Row>
      <Row>
        <Controller
          name="startTime"
          control={control}
          defaultValue={props.startTime}
          render={({ field }) => (
            <div className="mb-2 col">
              <Form.Label>{t("bookingForm.labelStartTime")}</Form.Label>
              <Form.Control disabled type="time" {...field} />
            </div>
          )}
        />
        <Controller
          name="estimatedEndTime"
          control={control}
          defaultValue={props.estimatedEndTime}
          render={({ field }) => (
            <div className="mb-2 col">
              <Form.Label>{t("bookingForm.labelEstimatedEndTime")}</Form.Label>
              <Form.Control disabled type="time" {...field} />
            </div>
          )}
        />
      </Row>
      <Controller
        name="destination"
        control={control}
        defaultValue={props.destination}
        render={({ field }) => (
          <div className="mb-2">
            <Form.Label>{t("bookingForm.labelDestination")}</Form.Label>
            <Form.Control disabled type="text" {...field} />
          </div>
        )}
      />
      <Controller
        name="name"
        control={control}
        defaultValue={props.name}
        render={({ field }) => (
          <div className="mb-2">
            <Form.Label>{t("bookingForm.labelName")}</Form.Label>
            <Form.Control disabled type="text" {...field} />
          </div>
        )}
      />
      <Controller
        name="email"
        control={control}
        defaultValue={props.email}
        render={({ field }) => (
          <div className="mb-2">
            <Form.Label>{t("bookingForm.labelEmail")}</Form.Label>
            <Form.Control disabled type="email" {...field} />
          </div>
        )}
      />
      <Controller
        name="annotations"
        control={control}
        defaultValue={props.annotations}
        render={({ field }) => (
          <div className="mb-2">
            <Form.Label>{t("bookingForm.labelAnnotations")}</Form.Label>
            <Form.Control disabled type="text" {...field} />
          </div>
        )}
      />
    </Form>
  );
}

export default BoatInfo;
